Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_ent.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_ent.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_ent.F90	(revision 3938)
@@ -29,4 +29,5 @@
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -144,6 +145,6 @@
 
       DO ji = kideb, kiut
-         zh_i(ji) = old_ht_i_b(ji) / nlay_i 
-         zh_s(ji) = old_ht_s_b(ji) / nlay_s
+         zh_i(ji) = old_ht_i_b(ji) / REAL( nlay_i ) 
+         zh_s(ji) = old_ht_s_b(ji) / REAL( nlay_s )
       END DO
 
@@ -165,6 +166,6 @@
       DO jk = 1, nlays0
          DO ji = kideb, kiut
-            snind(ji)  = jk        *      INT(MAX(0.0,SIGN(1.0,-dh_s_tot(ji)-zdeltah(ji)-epsi20))) &
-               + snind(ji) * (1 - INT(MAX(0.0,SIGN(1.0,-dh_s_tot(ji)-zdeltah(ji)-epsi20))))
+            snind(ji)  = jk        *      NINT(MAX(0.0,SIGN(1.0,-dh_s_tot(ji)-zdeltah(ji)))) &
+               + snind(ji) * (1 - NINT(MAX(0.0,SIGN(1.0,-dh_s_tot(ji)-zdeltah(ji)))))
             zdeltah(ji)= zdeltah(ji) + zh_s(ji)
          END DO ! ji
@@ -174,5 +175,5 @@
       !				   0 if not
       DO ji = kideb, kiut
-         snswi(ji)     = MAX(0,INT(-dh_s_tot(ji)/MAX(epsi20,ABS(dh_s_tot(ji)))))
+         snswi(ji)     = MAX(0,NINT(-dh_s_tot(ji)/MAX(epsi20,ABS(dh_s_tot(ji)))))
       END DO ! ji
 
@@ -189,6 +190,6 @@
       DO jk = 1, nlayi0
          DO ji = kideb, kiut
-            icsuind(ji) = jk          *      INT(MAX(0.0,SIGN(1.0,-dh_i_surf(ji)-zdeltah(ji)-epsi20))) &
-               + icsuind(ji) * (1 - INT(MAX(0.0,SIGN(1.0,-dh_i_surf(ji)-zdeltah(ji)-epsi20))))
+            icsuind(ji) = jk          *      NINT(MAX(0.0,SIGN(1.0,-dh_i_surf(ji)-zdeltah(ji)))) &
+               + icsuind(ji) * (1 - NINT(MAX(0.0,SIGN(1.0,-dh_i_surf(ji)-zdeltah(ji)))))
             zdeltah(ji) = zdeltah(ji) + zh_i(ji)
          END DO ! ji
@@ -199,5 +200,5 @@
       ! 	   0 if not
       DO ji = kideb, kiut
-         icsuswi(ji)  = MAX(0,INT(-dh_i_surf(ji)/MAX(epsi20 , ABS(dh_i_surf(ji)) ) ) )
+         icsuswi(ji)  = MAX(0,NINT(-dh_i_surf(ji)/MAX(epsi20 , ABS(dh_i_surf(ji)) ) ) )
       ENDDO
 
@@ -215,6 +216,6 @@
       DO jk = nlayi0, 1, -1
          DO ji = kideb, kiut
-            icboind(ji) = (nlayi0+1-jk) *      INT(MAX(0.0,SIGN(1.0,-dh_i_bott(ji)-zdeltah(ji)-epsi20))) &
-               &          + icboind(ji) * (1 - INT(MAX(0.0,SIGN(1.0,-dh_i_bott(ji)-zdeltah(ji)-epsi20)))) 
+            icboind(ji) = (nlayi0+1-jk) *      NINT(MAX(0.0,SIGN(1.0,-dh_i_bott(ji)-zdeltah(ji)))) &
+               &          + icboind(ji) * (1 - NINT(MAX(0.0,SIGN(1.0,-dh_i_bott(ji)-zdeltah(ji))))) 
             zdeltah(ji) = zdeltah(ji) + zh_i(ji)
          END DO
@@ -231,5 +232,5 @@
       ! 	   0 if ablation is on the way
       DO ji = kideb, kiut 
-         icboswi(ji) = MAX(0,INT(dh_i_bott(ji) / MAX(epsi20,ABS(dh_i_bott(ji)))))
+         icboswi(ji) = MAX(0,NINT(dh_i_bott(ji) / MAX(epsi20,ABS(dh_i_bott(ji)))))
       END DO
 
@@ -247,6 +248,6 @@
          DO ji = kideb, kiut
             snicind(ji) = (nlays0+1-jk) &
-               *      INT(MAX(0.0,SIGN(1.0,dh_snowice(ji)-zdeltah(ji)-epsi20))) + snicind(ji)   &
-               * (1 - INT(MAX(0.0,SIGN(1.0,dh_snowice(ji)-zdeltah(ji)-epsi20))))
+               *      NINT(MAX(0.0,SIGN(1.0,dh_snowice(ji)-zdeltah(ji)))) + snicind(ji)   &
+               * (1 - NINT(MAX(0.0,SIGN(1.0,dh_snowice(ji)-zdeltah(ji)))))
             zdeltah(ji) = zdeltah(ji) + zh_s(ji)
          END DO
@@ -257,5 +258,5 @@
       ! 	   0 if not
       DO ji = kideb, kiut
-         snicswi(ji)   = MAX(0,INT(dh_snowice(ji)/MAX(epsi20,ABS(dh_snowice(ji)))))
+         snicswi(ji)   = MAX(0,NINT(dh_snowice(ji)/MAX(epsi20,ABS(dh_snowice(ji)))))
       ENDDO
 
@@ -278,5 +279,5 @@
 
       DO ji = kideb, kiut
-         nbot0(ji) =  nlays0  + 1 - snind(ji) + ( 1. - snicind(ji) ) * snicswi(ji)
+         nbot0(ji) =  nlays0  + 1 - snind(ji) + ( 1 - snicind(ji) ) * snicswi(ji)
          ! cotes of the top of the layers
          zm0(ji,0) =  0._wp
@@ -290,11 +291,11 @@
             limsum = ( 1 - snswi(ji) ) * ( jk - 1 ) + snswi(ji) * ( jk + snind(ji) - 1 )
             limsum = MIN( limsum , nlay_s )
-            zm0(ji,jk) =  dh_s_tot(ji) + zh_s(ji) * limsum
-         END DO
-      END DO
-
-      DO ji = kideb, kiut
-         zm0(ji,nbot0(ji)) =  dh_s_tot(ji) - snicswi(ji) * dh_snowice(ji) + zh_s(ji) * nlays0
-         zm0(ji,1)         =  dh_s_tot(ji) * (1 -snswi(ji) ) + snswi(ji) * zm0(ji,1)
+            zm0(ji,jk) =  dh_s_tot(ji) + zh_s(ji) * REAL( limsum )
+         END DO
+      END DO
+
+      DO ji = kideb, kiut
+         zm0(ji,nbot0(ji)) =  dh_s_tot(ji) - REAL( snicswi(ji) ) * dh_snowice(ji) + zh_s(ji) * REAL( nlays0 )
+         zm0(ji,1)         =  dh_s_tot(ji) * REAL( 1 - snswi(ji) ) + REAL( snswi(ji) ) * zm0(ji,1)
       END DO
 
@@ -308,6 +309,6 @@
 
       DO ji = kideb, kiut         ! layer heat content
-         qm0    (ji,1) =  rhosn * (  cpic * ( rtt - ( 1. - snswi(ji) ) * tatm_ice_1d(ji)        &
-            &                                            - snswi(ji)   * t_s_b      (ji,1)  )   &
+         qm0    (ji,1) =  rhosn * (  cpic * ( rtt - REAL( 1 - snswi(ji) ) * tatm_ice_1d(ji)        &
+            &                                         - REAL( snswi(ji) ) * t_s_b      (ji,1)  )   &
             &                      + lfus  ) * zthick0(ji,1)
          zqts_in(ji)   =  zqts_in(ji) + qm0(ji,1) 
@@ -319,6 +320,6 @@
             limsum      = MIN( limsum , nlay_s )
             qm0(ji,jk)  = rhosn * ( cpic * ( rtt - t_s_b(ji,limsum) ) + lfus ) * zthick0(ji,jk)
-            zswitch = 1.0 - MAX (0.0, SIGN ( 1.0, epsi20 - ht_s_b(ji) ) )
-            zqts_in(ji) = zqts_in(ji) + ( 1. - snswi(ji) ) * qm0(ji,jk) * zswitch
+            zswitch = 1.0 - MAX (0.0, SIGN ( 1.0, - ht_s_b(ji) ) )
+            zqts_in(ji) = zqts_in(ji) + REAL( 1 - snswi(ji) ) * qm0(ji,jk) * zswitch
          END DO ! jk
       END DO ! ji
@@ -359,5 +360,5 @@
       !-------------------
       DO ji = kideb, kiut
-         zh_s(ji)  = ht_s_b(ji) / nlay_s
+         zh_s(ji)  = ht_s_b(ji) / REAL( nlay_s )
          z_s(ji,0) =  0._wp
       ENDDO
@@ -365,5 +366,5 @@
       DO jk = 1, nlay_s
          DO ji = kideb, kiut
-            z_s(ji,jk) =  zh_s(ji) * jk
+            z_s(ji,jk) =  zh_s(ji) * REAL( jk )
          END DO
       END DO
@@ -393,5 +394,5 @@
                   &                 - MAX(zm0(ji,layer0-1), z_s(ji,layer1-1))) / MAX(zhl0(ji,layer0),epsi10)) 
                q_s_b(ji,layer1) = q_s_b(ji,layer1) + zrl01(layer1,layer0)*qm0(ji,layer0)   &
-                  &                                * MAX(0.0,SIGN(1.0,nbot0(ji)-layer0+epsi20))
+                  &                                * MAX(0.0,SIGN(1.0,REAL(nbot0(ji)-layer0)))
             END DO
          END DO
@@ -440,5 +441,5 @@
       DO jk = 1, nlay_s
          DO ji = kideb, kiut
-            zswitch = MAX ( 0.0 , SIGN ( 1.0, epsi20 - ht_s_b(ji) ) )
+            zswitch = MAX ( 0.0 , SIGN ( 1.0, - ht_s_b(ji) ) )
             t_s_b(ji,jk) = rtt + ( 1.0 - zswitch ) * ( - zfac1 * q_s_b(ji,jk) + zfac2 )
          END DO
@@ -479,13 +480,13 @@
             limsum    =  ( (icsuswi(ji)*(icsuind(ji)+jk-1) + & 
                (1-icsuswi(ji))*jk))*(1-snicswi(ji)) + (jk-1)*snicswi(ji)
-            zm0(ji,jk)=  icsuswi(ji)*dh_i_surf(ji) + snicswi(ji)*dh_snowice(ji) &
-               +  limsum * zh_i(ji)
-         END DO
-      END DO
-
-      DO ji = kideb, kiut
-         zm0(ji,nbot0(ji)) =  icsuswi(ji)*dh_i_surf(ji) + snicswi(ji)*dh_snowice(ji) + dh_i_bott(ji) &
-            +  zh_i(ji) * nlayi0
-         zm0(ji,1)         =  snicswi(ji)*dh_snowice(ji) + (1-snicswi(ji))*zm0(ji,1)
+            zm0(ji,jk)=  REAL(icsuswi(ji))*dh_i_surf(ji) + REAL(snicswi(ji))*dh_snowice(ji) &
+               +  REAL(limsum) * zh_i(ji)
+         END DO
+      END DO
+
+      DO ji = kideb, kiut
+         zm0(ji,nbot0(ji)) =  REAL(icsuswi(ji))*dh_i_surf(ji) + REAL(snicswi(ji))*dh_snowice(ji) + dh_i_bott(ji) &
+            +  zh_i(ji) * REAL(nlayi0)
+         zm0(ji,1)         =  REAL(snicswi(ji))*dh_snowice(ji) + REAL(1-snicswi(ji))*zm0(ji,1)
       END DO
 
@@ -520,6 +521,6 @@
       !----------------------------
       DO ji = kideb, kiut        
-         ztmelts    = ( 1.0 - icboswi(ji) ) * (-tmut * s_i_b  (ji,nlayi0) )   &   ! case of melting ice
-            &       +         icboswi(ji)   * (-tmut * s_i_new(ji)        )   &   ! case of forming ice
+         ztmelts    = REAL( 1 - icboswi(ji) ) * (-tmut * s_i_b  (ji,nlayi0) )   &   ! case of melting ice
+            &       +     REAL( icboswi(ji) ) * (-tmut * s_i_new(ji)        )   &   ! case of forming ice
             &       + rtt                                                         ! in Kelvin
 
@@ -527,6 +528,6 @@
          ztform = t_i_b(ji,nlay_i)
          IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) ztform = t_bo_b(ji)
-         qm0(ji,nbot0(ji)) = ( 1.0 - icboswi(ji) )*qm0(ji,nbot0(ji))             &   ! case of melting ice
-            &              + icboswi(ji) * rhoic * ( cpic*(ztmelts-ztform)       &   ! case of forming ice
+         qm0(ji,nbot0(ji)) = REAL( 1 - icboswi(ji) )*qm0(ji,nbot0(ji))             &   ! case of melting ice
+            &              + REAL( icboswi(ji) ) * rhoic * ( cpic*(ztmelts-ztform)       &   ! case of forming ice
             + lfus *( 1.0-(ztmelts-rtt) / MIN ( (ztform-rtt) , - epsi10 ) )      & 
             - rcp*(ztmelts-rtt) ) * zthick0(ji,nbot0(ji)  )
@@ -539,5 +540,5 @@
          ! energy of the flooding seawater
          zqsnic = rau0 * rcp * ( rtt - t_bo_b(ji) ) * dh_snowice(ji) * &
-            (rhoic - rhosn) / rhoic * snicswi(ji) ! generally positive
+            (rhoic - rhosn) / rhoic * REAL(snicswi(ji)) ! generally positive
          ! Heat conservation diagnostic
          qt_i_in(ji,jl) = qt_i_in(ji,jl) + zqsnic 
@@ -548,5 +549,13 @@
          ! = enthalpy of snow + enthalpy of frozen water
          zqsnic         =  zqsnow(ji) + zqsnic
-         qm0(ji,1)      =  snicswi(ji) * zqsnic + ( 1 - snicswi(ji) ) * qm0(ji,1)
+         qm0(ji,1)      =  REAL(snicswi(ji)) * zqsnic + REAL( 1 - snicswi(ji) ) * qm0(ji,1)
+
+         zji = MOD( npb(ji) - 1, jpi ) + 1
+         zjj = ( npb(ji) - 1 ) / jpi + 1
+         IF ( (zji.eq.jiindx).AND.(zjj.eq.jjindx) ) THEN
+            !clemclem
+            WRITE(numout,*) 'lim_thd_ent : qldif = ', qldif_1d(ji)
+            !clemclem
+         ENDIF
 
       END DO ! ji
@@ -555,6 +564,6 @@
          DO ji = kideb, kiut
             ! Heat conservation
-            zqti_in(ji) = zqti_in(ji) + qm0(ji,jk) * MAX( 0.0 , SIGN(1.0,ht_i_b(ji)-epsi06+epsi20) ) &
-               &                                   * MAX( 0.0 , SIGN( 1. , nbot0(ji) - jk + epsi20 ) )
+            zqti_in(ji) = zqti_in(ji) + qm0(ji,jk) * MAX( 0.0 , SIGN(1.0,ht_i_b(ji)-epsi06) ) &
+               &                                   * MAX( 0.0 , SIGN( 1. , REAL(nbot0(ji) - jk) ) )
          END DO
       END DO
@@ -574,5 +583,5 @@
       !------------------
       DO ji = kideb, kiut
-         zh_i(ji) = ht_i_b(ji) / nlay_i
+         zh_i(ji) = ht_i_b(ji) / REAL( nlay_i )
       ENDDO
 
@@ -605,6 +614,6 @@
                q_i_b(ji,layer1) = q_i_b(ji,layer1) & 
                   + zrl01(layer1,layer0)*qm0(ji,layer0) &
-                  * MAX(0.0,SIGN(1.0,ht_i_b(ji)-epsi06+epsi20)) &
-                  * MAX(0.0,SIGN(1.0,nbot0(ji)-layer0+epsi20))
+                  * MAX(0.0,SIGN(1.0,ht_i_b(ji)-epsi06)) &
+                  * MAX(0.0,SIGN(1.0,REAL(nbot0(ji)-layer0)))
             END DO
          END DO
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_lac.F90	(revision 3938)
@@ -29,4 +29,5 @@
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -159,6 +160,5 @@
                   !Energy of melting q(S,T) [J.m-3]
                   e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl) / &
-                     MAX( area(ji,jj) * v_i(ji,jj,jl) ,  epsi10 ) * &
-                     nlay_i
+                     MAX( area(ji,jj) * v_i(ji,jj,jl) ,  epsi10 ) * REAL( nlay_i )
                   zindb      = 1.0-MAX(0.0,SIGN(1.0,-v_i(ji,jj,jl))) !0 if no ice and 1 if yes
                   e_i(ji,jj,jk,jl) = e_i(ji,jj,jk,jl)*unit_fac*zindb
@@ -185,9 +185,5 @@
 
       ! Default new ice thickness 
-      DO jj = 1, jpj
-         DO ji = 1, jpi
-            hicol(ji,jj) = hiccrit(1)
-         END DO
-      END DO
+      hicol(:,:) = hiccrit(1)
 
       IF (fraz_swi.eq.1.0) THEN
@@ -335,4 +331,5 @@
          CALL tab_2d_1d( nbpac, zvrel_ac  (1:nbpac)     , zvrel ,              &
             jpi, jpj, npac(1:nbpac) )
+         CALL tab_2d_1d( nbpac, rdmicif_1d  (1:nbpac)   , rdmicif, jpi, jpj, npac(1:nbpac) ) !martin
 
          !------------------------------------------------------------------------------!
@@ -410,4 +407,6 @@
             zdh_frazb(ji) = zfrazb*zv_newice(ji)
             zv_newice(ji) = ( 1.0 - zfrazb ) * zv_newice(ji)
+            !
+!clem@mv            rdmicif_1d(ji) = rdmicif_1d(ji) + zv_newice(ji) * rhoic  !martin
          END DO
 
@@ -415,21 +414,17 @@
          ! Salt flux due to new ice growth
          !---------------------------------
-         IF ( ( num_sal .EQ. 4 ) ) THEN 
-            DO ji = 1, nbpac
-               zji            = MOD( npac(ji) - 1, jpi ) + 1
-               zjj            = ( npac(ji) - 1 ) / jpi + 1
-               fseqv_1d(ji)   = fseqv_1d(ji) +                                     &
-                  ( sss_m(zji,zjj) - bulk_sal      ) * rhoic *       &
-                  zv_newice(ji) / rdt_ice
-            END DO
-         ELSE
-            DO ji = 1, nbpac
-               zji            = MOD( npac(ji) - 1, jpi ) + 1
-               zjj            = ( npac(ji) - 1 ) / jpi + 1
-               fseqv_1d(ji)   = fseqv_1d(ji) +                                     &
-                  ( sss_m(zji,zjj) - zs_newice(ji) ) * rhoic *       &
-                  zv_newice(ji) / rdt_ice
-            END DO ! ji
-         ENDIF
+!clem@mv         IF ( ( num_sal .EQ. 4 ) ) THEN 
+!clem@mv            DO ji = 1, nbpac
+!clem@mv               ! IOVINO
+!clem@mv               fseqv_1d(ji)   = fseqv_1d(ji) - bulk_sal * rhoic *  &
+!clem@mv                  zv_newice(ji) / rdt_ice
+!clem@mv            END DO
+!clem@mv         ELSE
+!clem@mv            DO ji = 1, nbpac
+!clem@mv               ! IOVINO
+!clem@mv               fseqv_1d(ji)   = fseqv_1d(ji)  - zs_newice(ji) * rhoic *   &
+!clem@mv                  zv_newice(ji) / rdt_ice
+!clem@mv            END DO ! ji
+!clem@mv         ENDIF
 
          !------------------------------------
@@ -460,5 +455,5 @@
             zjj                  = ( npac(ji) - 1 ) / jpi + 1
             diag_lat_gr(zji,zjj) = zv_newice(ji) / rdt_ice
-         END DO !ji
+          END DO !ji
 
          !------------------------------------------------------------------------------!
@@ -480,10 +475,10 @@
          DO ji = 1, nbpac
             ! vectorize
-            IF ( za_newice(ji) .GT. ( 1.0 - zat_i_ac(ji) ) ) THEN
-               zda_res(ji)    = za_newice(ji) - (1.0 - zat_i_ac(ji) )
+            IF ( za_newice(ji) .GT. ( amax - zat_i_ac(ji) ) ) THEN
+               zda_res(ji)    = za_newice(ji) - ( amax - zat_i_ac(ji) )
                zdv_res(ji)    = zda_res(ji) * zh_newice(ji) 
                za_newice(ji)  = za_newice(ji) - zda_res(ji)
                zv_newice(ji)  = zv_newice(ji) - zdv_res(ji)
-            ELSE
+           ELSE
                zda_res(ji) = 0.0
                zdv_res(ji) = 0.0
@@ -512,8 +507,8 @@
          DO ji = 1, nbpac
             jl = zcatac(ji)                                                           ! categroy in which new ice is put
-            zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , -za_old(ji,jl) ) )             ! zindb=1 if ice =0 otherwise
+            zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , -za_old(ji,jl) + epsi10 ) )             ! zindb=1 if ice =0 otherwise
             zhice_old(ji,jl) = zv_old(ji,jl) / MAX( za_old(ji,jl) , epsi10 ) * zindb  ! old ice thickness
             zdhex    (ji) = MAX( 0._wp , zh_newice(ji) - zhice_old(ji,jl) )           ! difference in thickness
-            zswinew  (ji) = MAX( 0._wp , SIGN( 1._wp , - za_old(ji,jl) + epsi11 ) )   ! ice totally new in jl category
+            zswinew  (ji) = MAX( 0._wp , SIGN( 1._wp , - za_old(ji,jl) + epsi10 ) )   ! ice totally new in jl category
          END DO
 
@@ -522,10 +517,10 @@
                jl = zcatac(ji)
                zqold   = ze_i_ac(ji,jk,jl) ! [ J.m-3 ]
-               zalphai = MIN( zhice_old(ji,jl) *   jk       / nlay_i , zh_newice(ji) )   &
-                  &    - MIN( zhice_old(ji,jl) * ( jk - 1 ) / nlay_i , zh_newice(ji) )
+               zalphai = MIN( zhice_old(ji,jl) * REAL( jk )     / REAL( nlay_i ), zh_newice(ji) )   &
+                  &    - MIN( zhice_old(ji,jl) * REAL( jk - 1 ) / REAL( nlay_i ), zh_newice(ji) )
                ze_i_ac(ji,jk,jl) = zswinew(ji) * ze_newice(ji)                                     &
-                  + ( 1.0 - zswinew(ji) ) * ( za_old(ji,jl)  * zqold * zhice_old(ji,jl) / nlay_i   &
+                  + ( 1.0 - zswinew(ji) ) * ( za_old(ji,jl)  * zqold * zhice_old(ji,jl) / REAL( nlay_i )  &
                   + za_newice(ji)  * ze_newice(ji) * zalphai                                       &
-                  + za_newice(ji)  * ze_newice(ji) * zdhex(ji) / nlay_i ) / ( ( zv_i_ac(ji,jl) ) / nlay_i )
+                  + za_newice(ji)  * ze_newice(ji) * zdhex(ji) / REAL( nlay_i ) ) / ( ( zv_i_ac(ji,jl) ) / REAL( nlay_i ) )
             END DO
          END DO
@@ -563,5 +558,5 @@
          DO jl = ice_cat_bounds(jm,1), ice_cat_bounds(jm,2)
             DO ji = 1, nbpac
-               zindb =  1._wp - MAX( 0._wp , SIGN( 1._wp , - za_i_ac(ji,jl ) ) )       ! zindb=1 if ice =0 otherwise
+               zindb =  1._wp - MAX( 0._wp , SIGN( 1._wp , - za_i_ac(ji,jl ) + epsi10 ) )       ! zindb=1 if ice =0 otherwise
                zhice_old(ji,jl) = zv_i_ac(ji,jl) / MAX( za_i_ac(ji,jl) , epsi10 ) * zindb
                zdhicbot (ji,jl) = zdv_res(ji)    / MAX( za_i_ac(ji,jl) , epsi10 ) * zindb    &
@@ -575,5 +570,5 @@
             DO jk = 1, nlay_i
                DO ji = 1, nbpac
-                  zthick0(ji,jk,jl) =  zhice_old(ji,jl) / nlay_i
+                  zthick0(ji,jk,jl) =  zhice_old(ji,jl) / REAL( nlay_i )
                   zqm0   (ji,jk,jl) =  ze_i_ac(ji,jk,jl) * zthick0(ji,jk,jl)
                END DO
@@ -594,9 +589,9 @@
                DO layer = 1, nlay_i + 1
                   DO ji = 1, nbpac
-                     zindb =  1._wp -  MAX( 0._wp , SIGN( 1._wp , - za_i_ac(ji,jl) ) ) 
+                     zindb =  1._wp -  MAX( 0._wp , SIGN( 1._wp , - za_i_ac(ji,jl) + epsi10 ) ) 
                      ! Redistributing energy on the new grid
-                     zweight = MAX (  MIN( zhice_old(ji,jl) * layer , zdummy(ji,jl) * jk )   &
-                        &    - MAX( zhice_old(ji,jl) * ( layer - 1 ) , zdummy(ji,jl) * ( jk - 1 ) ) , 0._wp )   &
-                        &    /( MAX(nlay_i * zthick0(ji,layer,jl),epsi10) ) * zindb
+                     zweight = MAX (  MIN( zhice_old(ji,jl) * REAL( layer ), zdummy(ji,jl) * REAL( jk ) )   &
+                        &    - MAX( zhice_old(ji,jl) * REAL( layer - 1 ) , zdummy(ji,jl) * REAL( jk - 1 ) ) , 0._wp )   &
+                        &    /( MAX(REAL(nlay_i) * zthick0(ji,layer,jl),epsi10) ) * zindb
                      ze_i_ac(ji,jk,jl) =  ze_i_ac(ji,jk,jl) + zweight * zqm0(ji,layer,jl)  
                   END DO ! ji
@@ -608,7 +603,7 @@
             DO jk = 1, nlay_i
                DO ji = 1, nbpac
-                  zindb =  1._wp -  MAX( 0._wp , SIGN( 1._wp , - zv_i_ac(ji,jl) ) ) 
+                  zindb =  1._wp -  MAX( 0._wp , SIGN( 1._wp , - zv_i_ac(ji,jl) + epsi10 ) ) 
                   ze_i_ac(ji,jk,jl) = ze_i_ac(ji,jk,jl)   &
-                     &              / MAX( zv_i_ac(ji,jl) , epsi10) * za_i_ac(ji,jl) * nlay_i * zindb
+                     &              / MAX( zv_i_ac(ji,jl) , epsi10) * za_i_ac(ji,jl) * REAL( nlay_i ) * zindb
                END DO
             END DO
@@ -620,5 +615,5 @@
          DO jl = 1, jpl
             DO ji = 1, nbpac
-               zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - za_i_ac(ji,jl) ) )  ! 0 if no ice and 1 if yes
+               zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - za_i_ac(ji,jl) + epsi10 ) )  ! 0 if no ice and 1 if yes
                zoa_i_ac(ji,jl)  = za_old(ji,jl) * zoa_i_ac(ji,jl) / MAX( za_i_ac(ji,jl) , epsi10 ) * zindb   
             END DO 
@@ -631,5 +626,5 @@
             DO jl = 1, jpl
                DO ji = 1, nbpac
-                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - zv_i_ac(ji,jl) ) )  ! 0 if no ice and 1 if yes
+                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - zv_i_ac(ji,jl) + epsi10 ) )  ! 0 if no ice and 1 if yes
                   zdv   = zv_i_ac(ji,jl) - zv_old(ji,jl)
                   zsmv_i_ac(ji,jl) = ( zsmv_i_ac(ji,jl) + zdv * zs_newice(ji) ) * zindb
@@ -637,4 +632,16 @@
             END DO   
          ENDIF
+
+         !--------------------------------
+         ! Update mass/salt fluxes (clem)
+         !--------------------------------
+         DO jl = 1, jpl
+            DO ji = 1, nbpac
+               zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - zv_i_ac(ji,jl) + epsi10 ) )  ! 0 if no ice and 1 if yes
+               zdv   = zv_i_ac(ji,jl) - zv_old(ji,jl)
+               rdmicif_1d(ji) = rdmicif_1d(ji) + zdv * rhoic !* zindb
+               fseqv_1d(ji)   =   fseqv_1d(ji) - zdv * rhoic * zs_newice(ji) / rdt_ice * zindb
+           END DO
+         END DO
 
          !------------------------------------------------------------------------------!
@@ -652,4 +659,5 @@
          END DO
          CALL tab_1d_2d( nbpac, fseqv , npac(1:nbpac), fseqv_1d  (1:nbpac) , jpi, jpj )
+         CALL tab_1d_2d( nbpac, rdmicif , npac(1:nbpac), rdmicif_1d  (1:nbpac) , jpi, jpj )
          !
       ENDIF ! nbpac > 0
@@ -660,5 +668,5 @@
       DO jl = 1, jpl
          DO jk = 1, nlay_i          ! heat content in 10^9 Joules
-            e_i(:,:,jk,jl) = e_i(:,:,jk,jl) * area(:,:) * v_i(:,:,jl) / nlay_i  / unit_fac 
+            e_i(:,:,jk,jl) = e_i(:,:,jk,jl) * area(:,:) * v_i(:,:,jl) / REAL( nlay_i )  / unit_fac 
          END DO
       END DO
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_sal.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_sal.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limthd_sal.F90	(revision 3938)
@@ -24,4 +24,5 @@
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -31,4 +32,5 @@
    PUBLIC   lim_thd_sal_init   ! called by iceini module
 
+   REAL(wp) ::   epsi20 = 1e-20_wp   ! constant values
    !!----------------------------------------------------------------------
    !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
@@ -67,14 +69,8 @@
       IF( num_sal == 1 ) THEN
          !
-         DO jk = 1, nlay_i
-            DO ji = kideb, kiut
-               s_i_b(ji,jk) =  bulk_sal
-            END DO ! ji
-         END DO ! jk
-         !
-         DO ji = kideb, kiut
-            sm_i_b(ji)      =  bulk_sal 
-         END DO ! ji
-         !
+         s_i_b  (kideb:kiut,1:nlay_i) =  bulk_sal 
+         sm_i_b (kideb:kiut)          =  bulk_sal
+         s_i_new(kideb:kiut)          =  bulk_sal
+        !
       ENDIF
 
@@ -90,4 +86,5 @@
          DO ji = kideb, kiut
             zhiold(ji) = ht_i_b(ji) - dh_i_bott(ji) - dh_snowice(ji) - dh_i_surf(ji)
+            zsiold(ji) = sm_i_b(ji)
          END DO
 
@@ -98,5 +95,5 @@
          DO jk = 1, nlay_i
             DO ji = kideb, kiut
-               ze_init(ji) = ze_init(ji) + q_i_b(ji,jk) * ht_i_b(ji) / nlay_i
+               ze_init(ji) = ze_init(ji) + q_i_b(ji,jk) * ht_i_b(ji) / REAL (nlay_i )
             END DO
          END DO
@@ -125,5 +122,4 @@
             ! only drainage terms ( gravity drainage and flushing )
             ! snow ice / bottom sources are added in lim_thd_ent to conserve energy
-            zsiold(ji) = sm_i_b(ji)
             sm_i_b(ji) = sm_i_b(ji) + dsm_i_fl_1d(ji) + dsm_i_gd_1d(ji)
 
@@ -156,10 +152,13 @@
          ! Salt flux - brine drainage
          !----------------------------
-         DO ji = kideb, kiut
+          DO ji = kideb, kiut
             i_ice_switch = 1._wp - MAX ( 0._wp, SIGN( 1._wp , - ht_i_b(ji) ) )
-            fsbri_1d(ji) = fsbri_1d(ji) - i_ice_switch * rhoic * a_i_b(ji) * ht_i_b(ji)         &
-               &         * ( MAX(dsm_i_gd_1d(ji) + dsm_i_fl_1d(ji), sm_i_b(ji) - zsiold(ji) ) ) / rdt_ice
+            fsbri_1d(ji) = fsbri_1d(ji) - i_ice_switch * rhoic * a_i_b(ji) * ht_i_b(ji) * ( sm_i_b(ji) - zsiold(ji) ) / rdt_ice
+            !i_ice_switch = 1._wp - MAX ( 0._wp, SIGN( 1._wp , - zhiold(ji) ) )
+            !fsbri_1d(ji) = fsbri_1d(ji) - i_ice_switch * rhoic * a_i_b(ji) * zhiold(ji) * ( sm_i_b(ji) - zsiold(ji) ) / rdt_ice
+            !clem fsbri_1d(ji) = fsbri_1d(ji) - i_ice_switch * rhoic * a_i_b(ji) * ht_i_b(ji)         &
+            !clem     &         * ( MAX(dsm_i_gd_1d(ji) + dsm_i_fl_1d(ji), sm_i_b(ji) - zsiold(ji) ) ) / rdt_ice
             IF( num_sal == 4 ) fsbri_1d(ji) = 0._wp
-         END DO ! ji
+          END DO ! ji
 
          ! Only necessary for conservation check since salinity is modified
@@ -211,23 +210,4 @@
       ENDIF ! num_sal
 
-      !------------------------------------------------------------------------------|
-      ! 5) Computation of salt flux due to Bottom growth
-      !------------------------------------------------------------------------------|
-
-      IF ( num_sal == 4 ) THEN
-         DO ji = kideb, kiut
-            zji = MOD( npb(ji) - 1 , jpi ) + 1
-            zjj =    ( npb(ji) - 1 ) / jpi + 1
-            fseqv_1d(ji) = fseqv_1d(ji) + ( sss_m(zji,zjj) - bulk_sal    )               &
-               &                        * rhoic * a_i_b(ji) * MAX( dh_i_bott(ji) , 0.0 ) / rdt_ice
-         END DO
-      ELSE
-         DO ji = kideb, kiut
-            zji = MOD( npb(ji) - 1 , jpi ) + 1
-            zjj =    ( npb(ji) - 1 ) / jpi + 1
-            fseqv_1d(ji) = fseqv_1d(ji) + ( sss_m(zji,zjj) - s_i_new(ji) )               &
-               &                        * rhoic * a_i_b(ji) * MAX( dh_i_bott(ji) , 0.0 ) / rdt_ice
-         END DO
-      ENDIF
       !
       CALL wrk_dealloc( jpij, ze_init, zhiold, zsiold )
